#include "header.h"

Linie::Linie() : Glyph() {
	black = new Color(0.0f, 0.0f, 0.0f);
	grey  = new Color(0.5f, 0.5f, 0.5f);
	duenn = new Brush(1.0);
	dick  = new Brush(5.0);
	Resource::ref(black);
	Resource::ref(grey);
	Resource::ref(duenn);
	Resource::ref(dick);
}

Linie::~Linie() {
	Resource::unref(black);
	Resource::unref(grey);
	Resource::unref(duenn);
	Resource::unref(dick);
}

void Linie::request(Requisition &req) const {
	Requirement rx(500.0,300.0,200.0,0.0);
	Requirement ry(500.0,300.0,200.0,0.0);
	req.require(Dimension_X,rx);
	req.require(Dimension_Y,ry);
}

void Linie::allocate(Canvas* c,const Allocation &alloc,Extension &ext) {
	ext.set(c, alloc);
}

void Linie::draw(Canvas *c,const Allocation &alloc) const {
	Coord x1 = alloc.left();
	Coord y1 = alloc.bottom();
	Coord x2 = alloc.right();
	Coord y2 = alloc.top();

	c->new_path();
	c->move_to(x1,y1);
	c->line_to(x2,y2);
	c->close_path();
	c->stroke(black,duenn);
}
