#include "header.h"

Linie::Linie() : Glyph() {
        black = new Color(0.0f, 0.0f, 0.0f);
        duenn = new Brush(1.0);
        Resource::ref(black);
        Resource::ref(duenn);
        linetype = 'd';
}

Linie::~Linie() {
        Resource::unref(black);
        Resource::unref(duenn);
}

void Linie::set_linetype(char type) {
        linetype = type;
}

void Linie::request(Requisition &req) const {
	Requirement rx(500.0,300.0,200.0,0.0);
	Requirement ry(500.0,300.0,200.0,0.0);
	req.require(Dimension_X,rx);
	req.require(Dimension_Y,ry);
}

void Linie::allocate(Canvas *c,const Allocation &a,Extension &ext) {
	ext.set(c, a);
}

void Linie::draw(Canvas *c,const Allocation &a) const {
	Coord x1 = a.left();
	Coord y1 = a.bottom();
	Coord x2 = a.right();
	Coord y2 = a.top();

	c->new_path();
	switch(linetype) {
	case 'd':
		c->move_to(x1,y1);
		c->line_to(x2,y2);
		break;
	case 'w':
		c->move_to(x1,(y1+y2)/2);
		c->line_to(x2,(y1+y2)/2);
		break;
	case 's':
		c->move_to((x1+x2)/2,y1);
		c->line_to((x1+x2)/2,y2);
		break;
	}
	c->close_path();
	c->stroke(black, duenn);
}
