#include "header.h"

MyDialog::MyDialog(Action *act, Style *s, Glyph *g) : Dialog(g, s) {
        WidgetKit& kit = *WidgetKit::instance();
        DialogKit& dkit = *DialogKit::instance();
        pushaction = act;
        Resource::ref(pushaction);
	editor = dkit.field_editor("Beeblebrox", kit.style(),
                 (FieldEditorAction*)pushaction);
        Resource::ref(editor);
        body(CreateGlyph(kit));
        append_input_handler(editor);
        next_focus();
}

MyDialog::~MyDialog() {
        Resource::unref(editor);
        Resource::unref(pushaction);
}

FieldEditor* MyDialog::get_editor() {
        return editor;
}

MonoGlyph* MyDialog::CreateGlyph(WidgetKit &kit) {
        LayoutKit& l = *LayoutKit::instance();

	Glyph *v1 = l.vglue(25.0,40.0,10.0);
	Glyph *v2 = l.vglue(15.0,30.0,5.0);
	Glyph *h1 = l.hglue(25.0,100.0,10.0);

        PolyGlyph *label_box =
          l.hbox(h1, kit.outset_frame(kit.fancy_label("Enter Name:")), h1);

        PolyGlyph *enter_box =
          l.hbox(h1, kit.outset_frame(editor), h1);

        PolyGlyph *exit_button =
          l.hbox(h1, kit.push_button("OK",pushaction), h1);

        MonoGlyph *my_all = kit.outset_frame(
          l.vbox(v1, label_box, v2, enter_box, v2, exit_button, v1));

        return my_all;
}
